/*
 * HSV2RGB.h
 *
 * Created: 19.11.2016 10:22:16
 *  Author: Thomas
 */ 

#ifndef HSV2RGB_H_
#define HSV2RGB_H_


//#define HSV2RGB_OPTIMIZED_SIZE

#include <avr/io.h>


typedef struct tagHSV {
	uint8_t H;
	uint8_t S;
	uint8_t V;
} __attribute__ ((packed)) HSV_T, *pHSV_T;

typedef struct tagRGB {
	uint8_t Red;
	uint8_t Green;
	uint8_t Blue;
} __attribute__ ((packed)) RGB_T, *pRGB_T;

typedef struct tagGRB {
	uint8_t Green;
	uint8_t Red;
	uint8_t Blue;
} __attribute__ ((packed)) GRB_T, *pGRB_T;

typedef struct tagBGR {
	uint8_t Blue;
	uint8_t Green;
	uint8_t Red;
} __attribute__ ((packed)) BGR_T, *pBGR_T;

typedef struct tagAPA102GBGR {
	uint8_t Global;
	uint8_t Blue;
	uint8_t Green;
	uint8_t Red;
} __attribute__ ((packed)) APA102GBGR_T, *pAPA102GBGR_T;


void HSV2RGB(pHSV_T, pRGB_T);
void HSV2GRB(pHSV_T, pGRB_T);
void HSV2BGR(pHSV_T, pBGR_T);
void HSV2APA102cGBGR(pHSV_T, pAPA102GBGR_T);


#endif /* HSV2RGB_H_ */